
x3 = 33;
y1 = 27;
load 'circle.csv';
load 'square.csv';
load 'in_out.csv';

% use one of these to select the data source
data = circle;
% data = square;
% data = in_out;


% do a median filter with a history length = 20
history = [];
median_filtering_data = [];
for i=1:length(data)
    history = [data(i,:); history];
    history = history(1:min([size(history,1), 20]),:);
    median_filtering_data = [median_filtering_data; median(history, 1)];
end


x_raw = (data(:,2).^2 - data(:,1).^2 + x3^2) / (2*x3) / x3;
y_raw = (data(:,2).^2 - data(:,3).^2 + y1^2) / (2*y1) / y1;
z_raw = sqrt(data(:,2).^2 - y_raw.^2 - x_raw.^2);


x_median =     (median_filtering_data(:,2).^2 - median_filtering_data(:,1).^2 + x3^2) / (2*x3) / x3;
y_median =     (median_filtering_data(:,2).^2 - median_filtering_data(:,3).^2 + y1^2) / (2*y1) / y1;
z_median = sqrt(median_filtering_data(:,2).^2 - y_median.^2 - x_median.^2);

% plot in XYZ
plot3( x_raw, y_raw, z_raw, 'b*', x_median,y_median,z_median,'r');

% plot in XY plane only
%plot( x_raw, y_raw, 'b*', x_median, y_median, 'r');

%end